SystemOrganization addCategory: #'Tank Game'!

Morph subclass: #GameBoard
	instanceVariableNames: 'keyBindings actionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!GameBoard commentStamp: 'GKB 7/13/2014 17:50' prior: 0!
I created this as a placeholder for the player input handler. Open the transcript to view the function flow. The temporary gameboard morph is in the top left, you can hover over that and start accpeting keyboard inputs. You can also click in the morph to hold keyboard focus when the mouse leaves. You can also call rebindKeys to rebind player functions and keys.
!

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
decreasePower
Transcript show: 'Decrease Power'.
Transcript cr.! !

!GameBoard methodsFor: 'display' stamp: 'GKB 7/13/2014 17:44'!
drawOn: aCanvas
"Temporary code to have a game board to recieve inputs"
| topAndBottom |
aCanvas fillRectangle: self horizontalBar color: self color.
"aCanvas fillColor: (Color yellow)"
"topAndBottom := self verticalBar areasOutside: self horizontalBar.
topAndBottom do: [ :each | aCanvas fillRectangle: each color: self color]"! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
fire
Transcript show: 'Fire gun'.
Transcript cr.! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 19:12'!
handleKeystroke: anEvent
| keyValue |

keyValue := keyBindings at: (anEvent keyValue)  ifAbsent: nil.
Transcript show: 'Keyboard Input: ', (anEvent keyCharacter) asString, '. Ascii Value: ', (anEvent keyValue) asString.
Transcript cr.

keyValue = #moveLeft
	ifTrue: [self moveLeft].
keyValue = #moveRight
	ifTrue: [self moveRight].
keyValue =#rotateCW
	ifTrue: [self rotateCW].
keyValue = #rotateCCW
	ifTrue: [self rotateCCW].
keyValue =#increasePower
	ifTrue: [self increasePower].
keyValue = #decreasePower
	ifTrue: [self decreasePower].
keyValue = #fire
	ifTrue: [self fire].
keyValue = nil
	ifTrue: [Transcript show: 'No action bound to this key.'.
			Transcript cr.].! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 17:31'!
handlesMouseDown: anEvent

	^true! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 13:11'!
handlesMouseOver: anEvent

	^true! !

!GameBoard methodsFor: 'display' stamp: 'GKB 7/13/2014 17:46'!
horizontalBar
| crossHeight |
crossHeight := (self height / 3.0) rounded.
^self bounds insetBy: 0 @ crossHeight! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
increasePower
Transcript show: 'Increase Power'.
Transcript cr.! !

!GameBoard methodsFor: 'initialize' stamp: 'GKB 7/13/2014 16:59'!
initialize
	super initialize.
	
	keyBindings := Dictionary new.
		
	keyBindings at:($a asciiValue)   put: #moveLeft. 
	keyBindings at:($d asciiValue) put: #moveRight. 
	keyBindings at:($j asciiValue)   put: #rotateCCW. 
	keyBindings at:($l asciiValue)   put: #moveCW. 
	keyBindings at:($i asciiValue)   put: #increasePower. 
	keyBindings at:($k asciiValue)   put: #decreasePower. 	
	keyBindings at:32   put: #fire. 			"32 = 	spaceBar"
						
	"keyBindings at:28   put: #rotateCCW. 	28 = 	leftArrow"
	"keyBindings at:29   put: #moveCW. 	29 = 	rightArrow"
	"keyBindings at:30   put: #increasePower. 	30 = 	upArrow"
	"keyBindings at:31   put: #decreasePower. 	31 = 	downArrow"
	
	actionList := Set new.
					
	actionList := #(	'moveLeft' 
			   		'moveRight' 
					'rotateCW' 
					'rotateCCW' 
					'increasePower' 
					'decreasePower' 
					'fire').			! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 19:11'!
mouseDown: anEvent

"game holds keyboard focus of the user clicks"
 anEvent hand newKeyboardFocus: self.



anEvent redButtonPressed
	ifTrue: [
			Transcript show: 'Red Mouse Button Click'.
			Transcript cr.
			self color: Color red].
anEvent yellowButtonPressed
	ifTrue: [Transcript show: 'Yellow Mouse Button Click'.
			Transcript cr.
			self color: Color yellow].
self changed.
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseEnter: anEvent
"anEvent hand newKeyboardFocus: self"
"mouseIn := true."! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseLeave: anEvent
"anEvent hand newKeyboardFocus: nil"
"mouseIn := false."! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
moveLeft
Transcript show: 'Move Tank Left'.
Transcript cr.! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
moveRight
Transcript show: 'Move Tank Right'.
Transcript cr.! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 18:53'!
rebindKeys

	| keyToChange changeToThis |
	
	keyToChange := 0.
	changeToThis := 0.
						
	keyToChange := UIManager default 
						chooseFrom: actionList 
						lines: #(2 4 6) 
						message: 'Which action would you like to rebind?'
						title: 'Rebind keys'.
	
						
	(keyToChange = 0)
		ifFalse: [ 
				
				(keyBindings keysAndValuesDo: 
				[ :key :val | val = (actionList at: keyToChange)  
					ifTrue:[changeToThis := UIManager default 
											request: 'Bind ', (actionList at: keyToChange),' to what key? It only takes the first charater' 
											initialAnswer: key asCharacter. 
							(changeToThis isNil) ifFalse: [ keyBindings removeKey: key]. 
						    ]  
				]).

				(changeToThis isNil) 
				ifFalse: [ 
					keyBindings at: (changeToThis first asciiValue) put:(actionList at: keyToChange).
						]
				].
	! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
rotateCCW
Transcript show: 'Rotate Tank Counterclockwise'.
Transcript cr.! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/13/2014 17:19'!
rotateCW
Transcript show: 'Rotate Tank Clockwise'.
Transcript cr.! !

Morph subclass: #TankMorph
	instanceVariableNames: 'turretAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

BorderedMorph subclass: #TankGame
	instanceVariableNames: 'tank hori vert spinR'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TankGame commentStamp: '<historical>' prior: 0!
A TankGame is a game.

Instance Variables
	hori:		<Object>
	spinR:		<Object>
	tank:		<Object>
	vert:		<Object>

hori
	- xxxxx

spinR
	- xxxxx

tank
	- xxxxx

vert
	- xxxxx
!

Object subclass: #TestClient3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TestClient3 commentStamp: '<historical>' prior: 0!
A TestClient3 is a client for sending/receiving messages.
!

!TestClient3 methodsFor: 'accessing' stamp: 'CaseyPiper 7/14/2014 00:39'!
start
    | socket bytesToSend sendBuf receiveBuf done bytesSent bytesReceived packetsSent 
packetsReceived t |

   Smalltalk garbageCollect.

   Transcript show: 'starting client/server TCP test'; cr.
   Transcript show: 'initializing network ... '.
   Transcript show: 'ok'; cr.

   socket := Socket newTCP.
   socket connectTo: (NetNameResolver addressForName: 'localhost') port: 12345.
   [
      socket waitForConnectionFor: 10.
      Transcript show: 'client endpoint created'; cr.
      bytesToSend := 1000000.
      sendBuf := String new: 4000 withAll: $x.
      receiveBuf := String new: 50000.
      done := false.
      bytesSent := bytesReceived := packetsSent := packetsReceived := 0.

      t := Time millisecondsToRun:[[done] whileFalse: 
          [(socket sendDone and: [bytesSent < bytesToSend]) ifTrue: 
             [ packetsSent := packetsSent + 1.
               bytesSent := bytesSent + (socket sendData: sendBuf)].
               socket dataAvailable ifTrue: 
                  [ packetsReceived := packetsReceived + 1.
                    bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf) ].
               done := bytesSent >= bytesToSend ].
           [bytesReceived < bytesToSend] whileTrue: 
               [ socket dataAvailable ifTrue: 
                   [ packetsReceived := packetsReceived + 1.
                     bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf)]]].
       socket closeAndDestroy.
      Transcript show: 'remoteClient TCP test done; time = ' , t printString; cr.
      Transcript
          show: packetsSent printString , ' packets, ' , bytesSent printString , 
                   ' bytes sent (' , (bytesSent * 1000 // t) printString , 
                   ' bytes/sec)'; cr.
      Transcript
          show: packetsReceived printString , ' packets, ' ,
          bytesReceived printString , ' bytes received (' , 
         (bytesReceived * 1000 // t) printString , ' bytes/sec)'; cr.

  ] forkAt: Processor userBackgroundPriority.! !

Object subclass: #TestServer3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TestServer3 commentStamp: '<historical>' prior: 0!
A TestServer3 is a simple server to receive and send data.
!

!TestServer3 methodsFor: 'accessing' stamp: 'CaseyPiper 7/14/2014 19:30'!
start
    | socket client buffer n |

   Transcript show: 'initializing network ... '.
   Transcript show: 'ok'; cr.
   socket := Socket newTCP.
   socket
       listenOn: 12345
       backlogSize: 5
       interface: (NetNameResolver addressForName: 'localhost').

    Transcript show: 'server endpoint created -- run client test in other image'; cr.

    buffer := String new: 4000.
    [
       client := socket waitForAcceptFor: 10.

       [ client isConnected] whileTrue: 
          [ client dataAvailable ifTrue: 
             [ n := client receiveDataInto: buffer.
               client sendData: buffer count: n ]].
          client closeAndDestroy.
          socket closeAndDestroy.
          Transcript cr; show: 'server endpoint destroyed'; cr.

   ] forkAt: Processor userBackgroundPriority.! !
